#include "gpstdio.h"
#include "gpstdlib.h"
#include "gpwrap.h"
#include "gpdef.h"
#include "gpmem.h"
#include "gpfont.h"

#include "chicken2.h"
#include "mouse.h"
#include "gfx.h"
#include "objects.h"
#include "sound.h"
#include "xlat.h"
//#include  <string.h>

const char menudata[5][20] = {"Restart","Continue","Mission","HighScores","Quit"};
const char alpha[27] = "abcdefghijklmnopqrstuvwxyz ";

char quit;
long chickens_killed;
Font font[1];
unsigned char ground[320];
char nr_chickens;
struct {
  short c1;
  short t;
  short difficulty;
} timer;
long points;
static struct {
  char name[10];
  long points;
} hiscore[5];

ubyte *vrscr, *backg, *pal, *pal2, *pobs;
ubyte *gamepal;
ubyte *gfx1;
ubyte *text, *text2;


char update = 0;

void GpMain(void *argv) {
  short x, y, c;
  short offs;
  short time, time2, die;
  char k;
  FILE *infile;

  GpClockSpeedChange(132000000, 0x3a011, 3);
  GpFatInit();
  GpRelativePathSet("gp:\\gpmm");
  pobs = allocate_mem(10000);
  backg = allocate_mem(76800);
  vrscr = allocate_mem(76800);
  gfx1 = allocate_mem(64000);
  gamepal = allocate_mem(768);
  load_pobs("gp:\\gpmm\\chicken2\\chicken2.pob", pobs);
  load_pcx("gp:\\gpmm\\chicken2\\tiles.pcx", gfx1,gamepal);
  load_hiscores();
  
  text = allocate_mem(1000);
  text2 = allocate_mem(1500);

  infile = gpfopen("gp:\\gpmm\\chicken2\\story.dat", "rb");
  for (c = 0; c < 542; c++) {
    text[c] = fgetc(infile) - 100;
  }
  gpfclose(infile);
  text[542] = 0;

  infile = gpfopen("gp:\\gpmm\\chicken2\\mission.dat", "rb");
  for (c = 0; c < 1085; c++) {
    text2[c] = fgetc(infile) - 100;
  }
  gpfclose(infile);
  text2[1085] = 0;

  init_gfx();
  init_sound();
  
  randomize();
  intro();
  set_palette(gamepal);

  play_again:
  init_mouse();
  generate_ground();
  init_objects();
  while (!quit) {
      timer.c1++;
      if (timer.c1 > 59) {
        timer.c1 = 0;
        timer.t--;
        if (timer.t < 1) quit = 1;
      }
      timer.difficulty++;
      if (timer.difficulty > 200) {
        timer.difficulty = 0;
        nr_chickens++;
        add_chicken();
      }
      get_mouse_pos();
      test_input();

      move_fire_fuel();
      move_fire();
      move_chicken();
      move_spark();
      move_blood();
      move_bdrop();
      move_mslogo();
      move_msdebr();
      move_programmer();
      move_crystal();
    
	copy_screen(vrscr, backg);//background copy
    draw_fire();
    draw_programmer();
    draw_mslogo();
    draw_msdebr();
    draw_spark();
    draw_bdrop();
    draw_blood();
    draw_crystal();
    draw_chicken();
    draw_output();
    put_pob(mouse.x, mouse.y, 0, pobs, vrscr);

    XlatVGABuffer(vrscr,gpDraw[ACTIVE_SURFACE].ptbuffer);
    GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
    ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  }
  XlatVGABuffer(vrscr,gpDraw[ACTIVE_SURFACE].ptbuffer);
//  GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],120,60,(char*)"GAME OVER",0xff);
//  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
//  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  stop_sound();
  sleep(3000);
  
  hiscore_screen();
  menu();
  goto play_again;
}

void save_hiscores(void) {
  FILE *outfile;
  short c, c2;
  long *p;
  long checksum = 0;

  outfile = gpfopen("gp:\\gpmm\\chicken2\\hiscore.dat", "wb");

  for (c = 0; c < 5; c++) {
    for (c2 = 0; c2 < 10; c2++) {
      fputc(hiscore[c].name[c2] + c2 + 1, outfile);
      checksum += hiscore[c].name[c2];
    }
    p = &hiscore[c].points;
    fwrite(p, 4, 1, outfile);
    checksum += hiscore[c].points;
  }
  fwrite(&checksum, 4, 1, outfile);

  gpfclose(outfile);
}

void load_hiscores(void) {
  FILE *infile;
  short c, c2;
  long *p;
  long sum = 0, checksum;

  infile = gpfopen("gp:\\gpmm\\chicken2\\hiscore.dat", "rb");

  for (c = 0; c < 5; c++) {
    for (c2 = 0; c2 < 10; c2++) {
      hiscore[c].name[c2] = fgetc(infile) - c2 - 1;
      sum += hiscore[c].name[c2];
    }
    p = &hiscore[c].points;
    fread(p, 4, 1, infile);
    sum += hiscore[c].points;
  }
  fread(&checksum, 4, 1, infile);

  gpfclose(infile);

  /*if (sum != checksum) {
    reset_hiscores();
    for (c = 0; c < 5; c++) strcpy(hiscore[c].name, " CHEATER! ");
  }*/
}

void draw_highscore(void){
  short c;
  char temp[50];
  clear_screen(gpDraw[ACTIVE_SURFACE].ptbuffer, 0);
  GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],115,20,(char*)"HIGH SCORES",0xff);
  for (c = 0; c < 5; c++) {
      if (hiscore[c].name != 0){ 
      	gm_sprintf(temp,"%i",hiscore[c].points);
      	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],40,40+c*20,(char*)hiscore[c].name,0xff);
      	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],220,40+c*20,(char*)temp,0xff);
      }
  }
}


void hiscore_screen(void) {
  short c, c2;
  char k = 0;
  char buf[10];
  char place = 5;
  int buttons;

  clear_screen(gpDraw[ACTIVE_SURFACE].ptbuffer, 0);
  for (c = 4; c >= 0; c--) { // check position
    if (points > hiscore[c].points) place--;
  }
  if (place < 4) {
    for (c = 4; c > place; c--) {
      hiscore[c].points = hiscore[c - 1].points;
      strcpy(hiscore[c].name, hiscore[c - 1].name);
    }
    hiscore[place].points = points;
    strcpy(hiscore[place].name, "          ");
  }
  if (place == 4) {
    hiscore[place].points = points;
    strcpy(hiscore[place].name, "          ");
  }

  if (place < 5) { // enter name!
    strcpy(buf, "          ");
    c=c2=0;
    buttons=GpKeyGet();
  	while(buttons!=GPC_VK_FA){
    	buf[c]=alpha[c2];
    	strcpy(hiscore[place].name, buf);
		if (buttons&GPC_VK_UP) c2++;
		if (buttons&GPC_VK_DOWN) c2--;
		if (buttons&GPC_VK_LEFT) {while(GpKeyGet()==GPC_VK_LEFT);c--;}
		if (buttons&GPC_VK_RIGHT) {while(GpKeyGet()==GPC_VK_RIGHT);c++;}

		if(c2<0)c2=26;
		if(c2>26)c2=0;
		if(c<0)c=0;
		if(c>9)c=9;

    	buttons=GpKeyGet();
    	draw_highscore();
    	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],120,210,(char*)"A to continue",0xff);
  		GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  		ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  		sleep(50);
    }
    save_hiscores();
    while(GpKeyGet()==GPC_VK_FA);
  }

  draw_highscore();
  GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],100,210,(char*)"START to continue",0xff);
  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  while(GpKeyGet()!=GPC_VK_START);
  while(GpKeyGet()==GPC_VK_START);
}

void draw_number(short x, short y, long n) {
  long p;
  long nr1, nr10, nr100, nr1000, nr10000, nr100000;

  p = n;
  nr100000 = p / 100000;
  p -= nr100000 * 100000;
  nr10000 = p / 10000;
  p -= nr10000 * 10000;
  nr1000 = p / 1000;
  p -= nr1000 * 1000;
  nr100 = p / 100;
  p -= nr100 * 100;
  nr10 = p / 10;
  p -= nr10 * 10;
  nr1 = p;

  if (n > 99999) put_pob(x, y, nr100000 + 28, pobs, vrscr);
  if (n > 9999) put_pob(x + 5, y, nr10000 + 28, pobs, vrscr);
  if (n > 999) put_pob(x + 10, y, nr1000 + 28, pobs, vrscr);
  if (n > 99) put_pob(x + 15 + 2, y, nr100 + 28, pobs, vrscr);
  if (n > 9) put_pob(x + 20 + 2, y, nr10 + 28, pobs, vrscr);
  put_pob(x + 25 + 2, y, nr1 + 28, pobs, vrscr);
}

void draw_output(void) {
  put_pob(130, 6, 27, pobs, vrscr);
  draw_number(160, 6, timer.t);
  draw_number(160, 14, points);
  draw_number(160, 22, chickens_killed);
}

void test_input(void) {
  short c, c2;
  char splat_sound = 0;
  if ((mouse.button == 1) && (mouse.hold == 0)) {
    mouse.hold = 1;
    timer.t--;
    play_sample(explode, sizeof(explode));

    for (c = 0; c < 5; c++) {
      add_spark(mouse.x, mouse.y, (float)(random_nr(40) - 20) / 10, (float)(random_nr(30) - 30) / 10);
    }

    for (c = 0; c < 40; c++) {
      if (chicken[c].live != 0) {
        if ((chicken[c].x > (mouse.x - 40)) && (chicken[c].x < (mouse.x + 40)) && (chicken[c].y > (mouse.y - 40)) && (chicken[c].y < (mouse.y + 40))) {
          chicken[c].live = 0;
          for (c2 = 0; c2 < 5; c2++) {
            add_blood(chicken[c].x, chicken[c].y, (float)(chicken[c].x - mouse.x + random_nr(8) - 4) / 20, (float)-40 / (abs(chicken[c].x - mouse.x + random_nr(16) - 8) + 10));
          }
          for (c2 = 0; c2 < 15; c2++) {
            add_bdrop(chicken[c].x, chicken[c].y, (float)(chicken[c].x - mouse.x + random_nr(32) - 16) / 20, (float)-40 / (abs(chicken[c].x - mouse.x + random_nr(32) - 16) + 10));
          }
          crystal_spawn++;
          if (crystal_spawn > (2 + nr_chickens / 8)) {
            crystal_spawn = 0;
            add_crystal(chicken[c].x, chicken[c].y, (float)(chicken[c].x - mouse.x + random_nr(32) - 16) / 20, (float)-100 / (abs(chicken[c].x - mouse.x + random_nr(32) - 16) + 10));
          }
          chickens_killed++;
          add_chicken();
          points += 100;
          if (splat_sound == 0) play_sample(splat, sizeof(splat));
          splat_sound = 1;
        }
      }
    }

    for (c = 0; c < 4; c++) {
      if (mslogo[c].live != 0) {
        if ((mslogo[c].x > (mouse.x - 40)) && (mslogo[c].x < (mouse.x + 40)) && (mslogo[c].y > (mouse.y - 40)) && (mslogo[c].y < (mouse.y + 40))) {
          mslogo[c].live = 0;
          for (c2 = 0; c2 < 15; c2++) {
            add_msdebr(mslogo[c].x, mslogo[c].y, (float)(mslogo[c].x - mouse.x + random_nr(32) - 16) / 20, (float)-40 / (abs(mslogo[c].x - mouse.x + random_nr(32) - 16) + 10));
          }
        }
      }
    }

    for (c = 0; c < 4; c++) {
      if (programmer[c].live != 0) {
        if ((programmer[c].x > (mouse.x - 40)) && (programmer[c].x < (mouse.x + 40)) && (programmer[c].y > (mouse.y - 40)) && (programmer[c].y < (mouse.y + 40))) {
          programmer[c].live = 0;
          for (c2 = 0; c2 < 10; c2++) {
            add_blood(programmer[c].x, programmer[c].y, (float)(programmer[c].x - mouse.x + random_nr(32) - 16) / 20, (float)-70 / (abs(programmer[c].x - mouse.x + random_nr(32) - 16) + 10));
          }
          for (c2 = 0; c2 < 30; c2++) {
            add_bdrop(programmer[c].x, programmer[c].y, (float)(programmer[c].x - mouse.x + random_nr(32) - 16) / 20, (float)-70 / (abs(programmer[c].x - mouse.x + random_nr(32) - 16) + 10));
          }
        }
      }
    }
  }
  if (mouse.button != 1) mouse.hold = 0;

  for (c = 0; c < 40; c++) {
    if (crystal[c].live != 0) {
      if ((crystal[c].x > (mouse.x - 8)) && (crystal[c].x < (mouse.x + 8)) && (crystal[c].y > (mouse.y - 8)) && (crystal[c].y < (mouse.y + 8))) {
        play_sample(plink, sizeof(plink));
        crystal[c].live = 0;
        timer.t += 3;
        points += 1000;
      }
    }
  }
}



void init_objects(void) {
  short c;

  quit = 0;
  nr_chickens = 10;
  chickens_killed = 0;
  points = 0;
  timer.c1 = 0;
  timer.t = 60;
  get_mouse_pos();
  crystal_spawn = 0;

  for (c = 0; c < 3200; c++) {
    fire_b[c] = 0;
    fire_c[c] = 0;
  }
  fire.c1 = 0;

  for (c = 0; c < 40; c++) {
    chicken[c].live = 0;
  }
  for (c = 0; c < 40; c++) {
    blood[c].live = 0;
  }
  for (c = 0; c < 4; c++) {
    mslogo[c].live = 0;
  }
  for (c = 0; c < 40; c++) {
    msdebr[c].live = 0;
  }
  for (c = 0; c < 4; c++) {
    programmer[c].live = 0;
  }
  for (c = 0; c < 20; c++) {
    fire_fuel[c].live = 0;
  }
  for (c = 0; c < 40; c++) {
    spark[c].live = 0;
  }
  for (c = 0; c < 240; c++) {
    bdrop[c].live = 0;
  }
  for (c = 0; c < 40; c++) {
    crystal[c].live = 0;
  }

  for (c = 0; c < nr_chickens; c++) {
    add_chicken();
  }
}

void generate_ground(void) {
  short x, y, c;
  unsigned char color;

  clear_screen(backg, /*24*/0x18181818);
  y = 120;
  for (x = 0; x < 320; x++) {
    y += random_nr(5) - 2;
    ground[x] = y;
    for (c = 239; c > ground[x]; c--) {
      color = gfx1[((c % 20) + 20) * 320 + (x % 20)];
      color = color + (c - 110) / 2;
      if (c == ground[x] + 1) {
        if (color < 96) color = 96;
        color += 5;
      }
      if (color > 111) color = 111;
      if (color < 96) color = 96;
      put_pixel(x, c, color, backg);
    }
  }

  y = 150;
  for (x = 0; x < 320; x++) {
    y += random_nr(3) - 1;
    ground[x] = y;
    for (c = 239; c > ground[x]; c--) {
      color = gfx1[(c % 20) * 320 + (x % 20)];
      color = color + (c - y) / 8;
      if (color > 63) color = 63;
      put_pixel(x, c, color, backg);
    }
    for (c = ground[x] + 19; c > ground[x]; c--) {
      color = gfx1[(c - ground[x]) * 320 + (x % 20) + 20];
      if (color != 0) put_pixel(x, c, color, backg);
    }
  }
}

// Loads a pcx file of any size.
void load_pcx(char *filename, ubyte *mem, ubyte *pal) {
  FILE *infile;
  unsigned short	w;
  unsigned long offs = 0;
  unsigned long length;
  unsigned char x, y;
  unsigned short width, height;

  if ((infile = gpfopen(filename, "rb")) == NULL) {
    return;
  }

  fseek(infile, 4 + 4, SEEK_SET);
  fread(&width, 2, 1, infile);
  fread(&height, 2, 1, infile);
  length = (height + 1) * (width + 1);
  fseek(infile, 128, SEEK_SET);

  while (offs < length) {
    x = fgetc(infile);
    if (x > 192) {
      y = fgetc(infile);
      for (w = 0 ; w < (x - 192) ; w++) {
        mem[offs] = y;
        offs++;
      }
    }
    if (x <= 192) {
      mem[offs] = x;
      offs++;
    }
  }

  while (x != 12) x = fgetc(infile);
  for (w = 0 ; w < 768 ; w++) pal[w] = fgetc(infile) / 4;
  gpfclose(infile);
}

void menu(void){
	int current,buttons,i;
	current=0;
	stop_sound();
  	while (1){
  		buttons = GpKeyGet();
		clear_screen(gpDraw[ACTIVE_SURFACE].ptbuffer, 0);
	    //XlatVGABuffer(vrscr,gpDraw[ACTIVE_SURFACE].ptbuffer);
    	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],120,10,(char*)"** PAUSE **",0xff);
    	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],110,60,(char*)"Chicken2 Menu",0xff);
    	for(i=0;i<5;i++){
    		GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],130,80+i*20,(char*)menudata[i],0xff);
    		if(i==current) GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],100,80+i*20,(char*)"->",0xff); 
    	}
    	GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],120,210,(char*)"A to select",0xff);
    
	    GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
	    ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
		
		if (buttons&GPC_VK_DOWN) current++;	
		if (buttons&GPC_VK_UP) current--;
		if (buttons&GPC_VK_FA) {
			if(current==0) {quit=1;break;}
			if(current==1) break;
			if(current==2){
				clear_screen(vrscr, 0);
  				put_text(5, 30, text2, 0, vrscr);
  				play_sample(explode, sizeof(explode));
  				XlatVGABuffer(vrscr,gpDraw[ACTIVE_SURFACE].ptbuffer);
  				GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],100,210,(char*)"START to continue",0xff);
  				GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  				ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  				while(GpKeyGet()!=GPC_VK_START);
  				while(GpKeyGet()==GPC_VK_START);
			}
			if(current==3) {
  				play_sample(explode, sizeof(explode));
				draw_highscore();
  				GpTextOut(NULL,&gpDraw[ACTIVE_SURFACE],100,210,(char*)"START to continue",0xff);
  				GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  				ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  				while(GpKeyGet()!=GPC_VK_START);
  				while(GpKeyGet()==GPC_VK_START);
  			}
			if(current==4) GpAppExit();

		}
		if(current<0)current=4;
		if(current>4)current=0;
		while(GpKeyGet()==buttons);
	}
}

void intro(void) {
  unsigned int backpal[256];

  load_font("gp:\\gpmm\\chicken2\\tiny.fnt", 0);
  
  palette_backup(backpal);

  // brainchild
  gm_memcpy(gpDraw[ACTIVE_SURFACE].ptbuffer,BC,sizeof(BC));
  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  play_sample(explode, sizeof(explode));
  sleep(3000);
  fade_out(10);
  palette_restore(backpal);

  // story
  clear_screen(vrscr, 0);
  put_text(60, 30, text, 0, vrscr);
  play_sample(explode, sizeof(explode));
  XlatVGABuffer(vrscr,gpDraw[ACTIVE_SURFACE].ptbuffer);
  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  sleep(8000);
  fade_out(10);
  palette_restore(backpal);

  // logo
  gm_memcpy(gpDraw[ACTIVE_SURFACE].ptbuffer,INTRO,sizeof(INTRO));
  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
  play_sample(explode, sizeof(explode));
  sleep(3000);
  fade_out(10);
  
  clear_screen(gpDraw[ACTIVE_SURFACE].ptbuffer, 0);
  GpSurfaceFlip(&gpDraw[ACTIVE_SURFACE]);
  ACTIVE_SURFACE = (ACTIVE_SURFACE + 1) & 0x01;
}



void put_text(short x_pos, short y_pos, char *text, char font_nr, char *mem) {
  unsigned short x, y;
  unsigned char color;
  unsigned short doffs, soffs;
  short xpos, ypos;
  unsigned short pos = 0;
  unsigned char c;
  unsigned short length;
  length = font[font_nr].height * font[font_nr].width;
  xpos = x_pos; ypos = y_pos;

  while ((c = text[pos]) != 0) {
    if (c == '*') {
      ypos += (font[font_nr].height + 1);
      xpos = x_pos;

    }
    else {
      soffs = c * length;
      doffs = (ypos << 8) + (ypos << 6) + xpos;

      for (y = 0; y < font[font_nr].height; y++) {
        for (x = 0; x < font[font_nr].width; x++) {
          color = font[font_nr].offset[soffs];
          if (color != 0) mem[doffs] = color;
          soffs++;
          doffs++;
        }
        doffs += (320 - font[font_nr].width);
      }
      xpos += font[font_nr].width;
    }
    pos++;
  }
}
