#include "gpdef.h"
#include "gpstdio.h"
#include "gpwrap.h"
#include "gpstdlib.h"

ulong filelength(char * file){
	ulong * p_size;
	GpFileGetSize(file,p_size );
	return *p_size;
}

typedef F_HANDLE FILE;

FILE __gp32_files__[1024];
int __gp32_files_pointer__=0;

FILE *gpfopen(const char *path, const char *mode)
{
	int i,j;
	FILE *ret=(FILE *)&__gp32_files__[__gp32_files_pointer__];
	ulong fopen_mode=OPEN_R;
	j=strlen(mode);
	for(i=0;i<j;i++)
		if (mode[i]=='w')
		{
			if (GpFileCreate(path,ALWAYS_CREATE,ret)!=SM_OK)
				return NULL;
			else
			{
				__gp32_files_pointer__++;
				return ret;
			}
		}
	if (GpFileOpen(path,fopen_mode,ret)!=SM_OK)
		return NULL;
	__gp32_files_pointer__++;
	return ret;	
}

int gpfclose(FILE *stream){ GpFileClose((*stream)); return 0; }

size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	if (stream!=NULL)
	{
		ulong buf_size=size*nmemb;
		ulong p_read_count;
		GpFileRead((*stream),ptr,buf_size,&p_read_count);
		return (p_read_count/size);
	}
	return 0;
}

size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream)
{
	if (stream!=NULL)
	{
		ulong count=size*nmemb;
		if (GpFileWrite((*stream),ptr,count)!=SM_OK)
			return 0;
		return (count/size);
	}
	return 0;
}

int fseek(FILE *stream, long offset, int whence)
{
	if (GpFileSeek((*stream),whence,offset,NULL)!=SM_OK)
		return -1;
	return 0;
}

long ftell(FILE *stream)
{
	long p_old_offset=0;
	
	if (GpFileSeek((*stream),FROM_CURRENT,0,&p_old_offset)!=SM_OK)
		return -1;
	return p_old_offset;
}

unsigned char fgetc(FILE *stream)
{
	unsigned char ret=0;
	if (fread((void *)&ret,1,1,stream)!=1)
		return EOF;
	return ret;
}

unsigned char fputc(int c, FILE *stream)
{
	unsigned char ret=c;
	if (fwrite((void *)&ret,1,1,stream)!=1)
		return EOF;
	return ret;
}

size_t strlen(const char *s) { return ((size_t)gm_lstrlen(s)); }
char *strcpy(char *s1, const char *s2){ return gm_strcpy(s1,s2); }
int abs(int j){	if (j<0) return -j;	return j; }

void sleep(long delay){
	GpThreadSleep(2*delay);
}